diff -Nur linux-2.6.9-intc1/arch/arm/boot/compressed/head.S linux-2.6.9-intc1-mih1/arch/arm/boot/compressed/head.S
--- linux-2.6.9-intc1/arch/arm/boot/compressed/head.S	2004-10-18 17:55:07.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/boot/compressed/head.S	2005-05-02 17:21:06.000000000 -0400
@@ -53,10 +53,18 @@
 		.macro	writeb, rb
 		strb	\rb, [r3, #0]
 		.endm
-#elif defined(CONFIG_ARCH_PXA) /* Xscale-type */
+#elif defined(CONFIG_ARCH_PXA) /* Xscale-type output: 1=FFUART,2=BTUART,7=STUART */
 		.macro 	loadsp, rb
 		mov	\rb, #0x40000000
+#if defined(CONFIG_INITIAL_UART1)	/* Output to FFUART */
 		orr	\rb, \rb, #0x00100000
+#elif defined(CONFIG_INITIAL_UART2)	/* Output to BTUART */
+		orr	\rb, \rb, #0x00200000
+#elif defined(CONFIG_INITIAL_UART3)	/* Output to STUART */
+		orr	\rb, \rb, #0x00700000
+#else
+#warning  No serial ouput selected!
+#endif
 		.endm
 		.macro	writeb, rb
 		strb	\rb, [r3, #0]
diff -Nur linux-2.6.9-intc1/arch/arm/Kconfig linux-2.6.9-intc1-mih1/arch/arm/Kconfig
--- linux-2.6.9-intc1/arch/arm/Kconfig	2005-05-02 15:16:10.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/Kconfig	2005-05-01 14:54:02.000000000 -0400
@@ -257,6 +257,20 @@
 	depends on SA1111 || ARCH_IXP4XX
 	default y
 
+#####################################################################
+# PXA2xx serial output
+if ARCH_PXA
+	choice
+	prompt "Initial UART output port (during uncompressing and printchar debugging)"
+		config INITIAL_UART1
+		       bool "UART1 (FFUART)"
+		config INITIAL_UART2
+		       bool "UART2 (BTUART)"
+		config INITIAL_UART3
+		       bool "UART3 (STUART)"
+	endchoice
+endif
+
 source arch/arm/mm/Kconfig
 
 #  bool 'Use XScale PMU as timer source' CONFIG_XSCALE_PMU_TIMER
@@ -357,7 +371,7 @@
 
 config CPU_FREQ
 	bool "Support CPU clock change (EXPERIMENTAL)"
-	depends on (ARCH_SA1100 || ARCH_INTEGRATOR || MACH_MAINSTONE) && EXPERIMENTAL
+	depends on (ARCH_SA1100 || ARCH_INTEGRATOR || MACH_MAINSTONE || MACH_GLENCOE) && EXPERIMENTAL
 	help
 	  CPU clock scaling allows you to change the clock speed of the
 	  running CPU on the fly. This is a nice method to save battery power,
@@ -589,7 +603,7 @@
 
 config LEDS
 	bool "Timer and CPU usage LEDs"
-	depends on ARCH_NETWINDER || ARCH_EBSA110 || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_CDB89712 || ARCH_P720T || ARCH_OMAP || ARCH_VERSATILE_PB || ARCH_IMX
+	depends on ARCH_NETWINDER || ARCH_EBSA110 || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || MACH_GLENCOE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_CDB89712 || ARCH_P720T || ARCH_OMAP || ARCH_VERSATILE_PB || ARCH_IMX
 	help
 	  If you say Y here, the LEDs on your machine will be used
 	  to provide useful information about your current system status.
@@ -602,8 +616,8 @@
 	  system, but the driver will do nothing.
 
 config LEDS_TIMER
-	bool "Timer LED" if LEDS && (ARCH_NETWINDER || ARCH_EBSA285 || ARCH_SHARK || MACH_MAINSTONE || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_P720T || ARCH_VERSATILE_PB || ARCH_IMX)
-	depends on ARCH_NETWINDER || ARCH_EBSA110 || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_CDB89712 || ARCH_P720T || ARCH_OMAP || ARCH_VERSATILE_PB || ARCH_IMX
+	bool "Timer LED" if LEDS && (ARCH_NETWINDER || ARCH_EBSA285 || ARCH_SHARK || MACH_MAINSTONE || MACH_GLENCOE || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_P720T || ARCH_VERSATILE_PB || ARCH_IMX)
+	depends on ARCH_NETWINDER || ARCH_EBSA110 || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || MACH_GLENCOE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_CDB89712 || ARCH_P720T || ARCH_OMAP || ARCH_VERSATILE_PB || ARCH_IMX
 	default y if ARCH_EBSA110
 	help
 	  If you say Y here, one of the system LEDs (the green one on the
@@ -618,7 +632,7 @@
 
 config LEDS_CPU
 	bool "CPU usage LED"
-	depends on LEDS && (ARCH_NETWINDER || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_P720T || ARCH_VERSATILE_PB || ARCH_IMX)
+	depends on LEDS && (ARCH_NETWINDER || ARCH_EBSA285 || ARCH_SHARK || ARCH_CO285 || ARCH_SA1100 || ARCH_LUBBOCK || MACH_MAINSTONE || MACH_GLENCOE || ARCH_PXA_IDP || ARCH_INTEGRATOR || ARCH_P720T || ARCH_VERSATILE_PB || ARCH_IMX)
 	help
 	  If you say Y here, the red LED will be used to give a good real
 	  time indication of CPU usage, by lighting whenever the idle task
diff -Nur linux-2.6.9-intc1/arch/arm/kernel/debug.S linux-2.6.9-intc1-mih1/arch/arm/kernel/debug.S
--- linux-2.6.9-intc1/arch/arm/kernel/debug.S	2004-10-18 17:53:46.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/kernel/debug.S	2005-05-02 17:21:56.000000000 -0400
@@ -239,13 +239,21 @@
 		.endm
 
 #elif defined(CONFIG_ARCH_PXA)
-
+						/* Xscale-type output: 1=FFUART,2=BTUART,7=STUART */
 		.macro	addruart,rx
 		mrc	p15, 0, \rx, c1, c0
 		tst	\rx, #1			@ MMU enabled?
 		moveq	\rx, #0x40000000		@ physical
 		movne	\rx, #io_p2v(0x40000000)	@ virtual
-		orr	\rx, \rx, #0x00100000
+#if defined(CONFIG_INITIAL_UART1)	/* Output to FFUART */
+		orr	\rb, \rb, #0x00100000
+#elif defined(CONFIG_INITIAL_UART2)	/* Output to BTUART */
+		orr	\rb, \rb, #0x00200000
+#elif defined(CONFIG_INITIAL_UART3)	/* Output to STUART */
+		orr	\rb, \rb, #0x00700000
+#else
+#warning No serial output selected
+#endif
 		.endm
 
 		.macro	senduart,rd,rx
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/cpu-freq-pxa27x.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/cpu-freq-pxa27x.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/cpu-freq-pxa27x.c	2005-05-02 15:16:10.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/cpu-freq-pxa27x.c	2005-05-01 01:18:02.000000000 -0400
@@ -15,12 +15,12 @@
 #include <linux/cpufreq.h>
 #include <linux/config.h>
 #include <linux/ioctl.h>
+#include <linux/delay.h>
 #include <asm/hardware.h>
 #include <asm/io.h>
 #include <asm/delay.h>
 #include <asm/mach-types.h>
 #include <asm/arch/pxa-regs.h>
-#include <asm/arch/mainstone.h>
 
 #include "cpu-freq-voltage-pxa27x.h"
 
@@ -274,7 +274,6 @@
 static int enter_13M(void)
 {
 	int cccr;
-	int clkcfg;
 
 	if (CCCR & (1 << 31))
 		return 1;
@@ -309,7 +308,7 @@
 				unsigned int turbo_mode_flag,
 				unsigned int memc_clock_flag)
 {
-	int cccr, ccsr, clkcfg;
+	int cccr, clkcfg;
 	unsigned int time_delay;
 
 	if (!(CCCR & (1 << 31)))
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/generic.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/generic.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/generic.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/generic.c	2005-05-01 01:22:32.000000000 -0400
@@ -117,7 +117,7 @@
 	},
 };
 
-static u64 pxamci_dmamask = 0xffffffffUL;
+static u64 pxamci_dmamask = ~(u32)0;
 
 static struct platform_device pxamci_device = {
 	.name		= "pxa2xx-mci",
@@ -219,6 +219,33 @@
 	.id		= 2,
 };
 
+#if defined(CONFIG_PXA27x)
+
+static struct resource pxartc_resource[] = {
+	[0] = {
+                .start  = 0x40900000,
+                .end    = 0x409000ff,
+		.flags  = IORESOURCE_MEM,
+	},
+	[1] = {
+		.start = IRQ_RTC1Hz,
+		.end   = IRQ_RTC1Hz,
+		.flags = IORESOURCE_IRQ,
+	},
+	[2] = {
+		.start = IRQ_RTCAlrm,
+		.end   = IRQ_RTCAlrm,
+		.flags = IORESOURCE_IRQ
+	}
+};
+
+struct platform_device pxartc_device = {
+	.name		  = "pxartc",
+	.id		  = -1,
+	.num_resources	  = ARRAY_SIZE(pxartc_resource),
+	.resource	  = pxartc_resource,
+};
+
 static struct resource pxacamera_resources[] = {
         [0] = {
                 .start  = 0x50000000,
@@ -232,7 +259,7 @@
         },
 };
 
-static u64 pxa_camera_dmamask = 0xffffffffUL;
+static u64 pxa_camera_dmamask = ~(u64)0;
 
 static struct platform_device pxacamera_device = {
         .name           = "pxa2xx-camera",
@@ -241,34 +268,34 @@
                 .dma_mask = &pxa_camera_dmamask,
                 .coherent_dma_mask = 0xffffffff,
 	},
-		.num_resources  = ARRAY_SIZE(pxacamera_resources),
+	.num_resources  = ARRAY_SIZE(pxacamera_resources),
         .resource       = pxacamera_resources,
 };
 
 static struct resource pxaac97_resources[] = {
-        [0] = {
-                .start  = 0x40500000,
-                .end   	= 0x40500fff,
-                .flags  = IORESOURCE_MEM,
-        },
-        [1] = {
-                .start  = IRQ_AC97,
-                .end    = IRQ_AC97,
-                .flags  = IORESOURCE_IRQ,
-        },
+	[0] = {
+		.start	= 0x40500000,
+		.end	= 0x405ffffc,
+		.flags	= IORESOURCE_MEM,
+	},
+	[1] = {
+		.start	= IRQ_AC97,
+		.end	= IRQ_AC97,
+		.flags	= IORESOURCE_IRQ,
+	},
 };
 
-static u64 pxa_ac97_dmamask = 0xffffffffUL;
+static u64 pxaac97_dmamask = ~(u64)0;
 
 static struct platform_device pxaac97_device = {
-        .name           = "pxa2xx-ac97",
-        .id             = -1,
-        .dev            = {
-                .dma_mask = &pxa_ac97_dmamask,
-                .coherent_dma_mask = 0xffffffff,
-    },
-    	.num_resources  = ARRAY_SIZE(pxaac97_resources),
-        .resource       = pxaac97_resources,
+	.name		= "pxa-ac97",
+	.id		= -1,
+	.dev		= {
+		.dma_mask = &pxaac97_dmamask,
+		.coherent_dma_mask = 0xffffffff,
+	},
+	.num_resources	= ARRAY_SIZE(pxaac97_resources),
+	.resource	= pxaac97_resources,
 };
 
 static struct platform_device pxaflash_device = {
@@ -276,6 +303,8 @@
         .id             = -1,
 };
 
+#endif
+
 static struct platform_device *devices[] __initdata = {
 	&pxamci_device,
 	&udc_device,
@@ -283,9 +312,12 @@
 	&ffuart_device,
 	&btuart_device,
 	&stuart_device,
+#if defined(CONFIG_PXA27x)
+	&pxartc_device,
 	&pxacamera_device,
 	&pxaac97_device,
 	&pxaflash_device,
+#endif
 };
 
 static int __init pxa_init(void)
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/glencoe.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/glencoe.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/glencoe.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/glencoe.c	2005-05-01 01:25:46.000000000 -0400
@@ -0,0 +1,275 @@
+/*
+ *  linux/arch/arm/mach-pxa/glencoe.c
+ *
+ *  Support for the Intel B3G Glencoe Platform.
+ *	based on mainstone.c
+ *  Changed by Matthias Ihmig <m.ihmig@mytum.de>
+ *
+ *  Original author:	Nicolas Pitre
+ *  Created:		Nov 05, 2002
+ *  Copyright:		MontaVista Software Inc.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 2 as
+ *  published by the Free Software Foundation.
+ */
+
+#include <linux/init.h>
+#include <linux/device.h>
+#include <linux/interrupt.h>
+#include <linux/sched.h>
+#include <linux/bitops.h>
+#include <linux/fb.h>
+#include <linux/mmc/host.h>
+
+#include <asm/types.h>
+#include <asm/setup.h>
+#include <asm/memory.h>
+#include <asm/mach-types.h>
+#include <asm/hardware.h>
+#include <asm/irq.h>
+
+#include <asm/mach/arch.h>
+#include <asm/mach/map.h>
+#include <asm/mach/irq.h>
+
+#include <asm/arch/pxa-regs.h>
+#include <asm/arch/glencoe.h>
+#include <asm/arch/audio.h>
+#include <asm/arch/pxafb.h>
+#include <asm/arch/mmc.h>
+
+#include "generic.h"
+
+
+static void __init glencoe_init_irq(void)
+{
+	pxa_init_irq();
+}
+/* Framework future power code.
+static int gln_audio_startup(snd_pcm_substream_t *substream, void *priv)
+{
+	// audio routing/power up/GPIOs/...
+	if (substream->stream == SNDRV_PCM_STREAM_PLAYBACK) ;
+	return 0;
+}
+static void gln_audio_shutdown(snd_pcm_substream_t *substream, void *priv)
+{
+	if (substream->stream == SNDRV_PCM_STREAM_PLAYBACK) ;
+}
+static void gln_audio_suspend(void *priv)
+{ }
+static void gln_audio_resume(void *priv)
+{ }
+*/
+
+static pxa2xx_audio_ops_t gln_audio_ops = {
+/*	.startup	= gln_audio_startup,
+	.shutdown	= gln_audio_shutdown,
+	.suspend	= gln_audio_suspend,
+	.resume		= gln_audio_resume,*/
+};
+
+static struct platform_device gln_audio_device = {
+	.name		= "pxa2xx-ac97",
+	.id		= -1,
+	.dev		= { .platform_data = &gln_audio_ops },
+};
+
+static void glencoe_backlight_power(int on)
+{
+	if (on) {
+		pxa_gpio_mode(GLN_GPIO_BL_PWR_ON | GPIO_OUT);
+		pxa_gpio_mode(GLN_BACKLIGHT_PWM_MD);
+		pxa_set_cken(GLN_BACKLIGHT_PWM_CKEN, 1);
+		GLN_BACKLIGHT_PWM_CTRL = 0;
+		GLN_BACKLIGHT_PWM_PWDUTY = 0x3ff;
+		GLN_BACKLIGHT_PWM_PERVAL = 0x3ff;
+		GPIO_set(GLN_GPIO_BL_PWR_ON);
+	} else {
+		PWM_CTRL0 = 0;
+		GLN_BACKLIGHT_PWM_PWDUTY = 0x0;
+		GLN_BACKLIGHT_PWM_PERVAL = 0x3ff;
+		pxa_set_cken(GLN_BACKLIGHT_PWM_CKEN, 0);
+		GPIO_clr(GLN_GPIO_BL_PWR_ON);
+	}
+}
+
+static void glencoe_lcd_power(int on)
+{
+	if (on) {
+		GPIO_set(GLN_GPIO_LCD_PWR_ON);
+	} else {
+		GPIO_clr(GLN_GPIO_LCD_PWR_ON);
+	}
+}
+
+static struct pxafb_mach_info toshiba_ltm04c380k __initdata = {
+	.pixclock		= 50000,
+	.xres			= 640,
+	.yres			= 480,
+	.bpp			= 16,
+	.hsync_len		= 1,
+	.left_margin		= 0x9f,
+	.right_margin		= 1,
+	.vsync_len		= 44,
+	.upper_margin		= 0,
+	.lower_margin		= 0,
+	.sync			= FB_SYNC_HOR_HIGH_ACT|FB_SYNC_VERT_HIGH_ACT,
+	.lccr0			= LCCR0_Act,
+	.lccr3			= LCCR3_PCP,
+	.pxafb_backlight_power	= glencoe_backlight_power,
+	.pxafb_lcd_power	= glencoe_lcd_power,
+};
+
+static struct pxafb_mach_info toshiba_ltm035a776c __initdata = {
+	.pixclock		= 110000,
+	.xres			= 240,
+	.yres			= 320,
+	.bpp			= 16,
+	.hsync_len		= 4,
+	.left_margin		= 8+4,	/* 8 */
+	.right_margin		= 20,	/* 14 */
+	.vsync_len		= 3,
+	.upper_margin		= 1+4,	/* 1 */
+	.lower_margin		= 10,	/* 6 */
+	.sync			= FB_SYNC_HOR_HIGH_ACT|FB_SYNC_VERT_HIGH_ACT,
+	.lccr0			= LCCR0_Act,
+	.lccr3			= LCCR3_PCP,
+	.pxafb_backlight_power	= glencoe_backlight_power,
+	.pxafb_lcd_power	= glencoe_lcd_power,
+};
+
+/*
+ * MMC/SD Device
+ *
+ * The card detect interrupt isn't debounced and even triggers
+ * too early on Glencoe, so delay it by HZ/4 to give the card
+ * a chance to fully insert/eject.
+ */
+static struct mmc_detect {
+	struct timer_list detect_timer;
+	void *devid;
+} mmc_detect;
+
+static void mmc_detect_callback(unsigned long data)
+{
+#ifdef CONFIG_MMC
+	mmc_detect_change(mmc_detect.devid);
+#endif
+}
+
+static irqreturn_t glencoe_mmc_detect_int(int irq, void *devid, struct pt_regs *regs)
+{
+	mmc_detect.devid=devid;
+	mod_timer(&mmc_detect.detect_timer, jiffies + HZ/4);
+	return IRQ_HANDLED;
+}
+
+static int glencoe_mci_init(struct device *dev, irqreturn_t (*unused_detect_int)(int, void *, struct pt_regs *), void *data)
+{
+	struct mmc_host *mmc = (struct mmc_host*)data;
+	int err;
+
+	pxa_set_cken(CKEN12_MMC, 0);
+	pxa_gpio_mode(GPIO32_MMCCLK_MD);
+	pxa_gpio_mode(GPIO112_MMCCMD_MD);
+	pxa_gpio_mode(GPIO92_MMCDAT0_MD);
+	pxa_gpio_mode(GPIO109_MMCDAT1_MD);
+	pxa_gpio_mode(GPIO110_MMCDAT2_MD);
+	pxa_gpio_mode(GPIO111_MMCDAT3_MD);
+
+	pxa_gpio_mode(GLN_GPIO_nMMC_CARD_DET | GPIO_IN);
+	pxa_gpio_mode(GLN_GPIO_MMC_PWR_ON | GPIO_OUT);
+	GPIO_clr(GLN_GPIO_MMC_PWR_ON);
+	
+
+	init_timer(&mmc_detect.detect_timer);
+	mmc_detect.detect_timer.function = mmc_detect_callback;
+	mmc_detect.detect_timer.data = (unsigned long) &mmc_detect;
+	
+	err = request_irq(GLENCOE_MMC_IRQ, glencoe_mmc_detect_int, SA_INTERRUPT,
+			     "MMC card detect", (void *)mmc);
+	if (err) {
+		printk(KERN_ERR "glencoe_mci_init: MMC/SD: can't request MMC card detect IRQ\n");
+		return -1;
+	}
+	set_irq_type(GLENCOE_MMC_IRQ, IRQT_BOTHEDGE);
+	return 0;
+}
+
+static void glencoe_mci_setpower(struct device *dev, unsigned int vdd)
+{
+	struct pxamci_platform_data* p_d = dev->platform_data; 
+
+	if ( vdd == 0 ) {
+		printk(KERN_DEBUG "glencoe_mci_setpower: off\n");
+		pxa_gpio_mode(GLN_GPIO_MMC_PWR_ON | GPIO_OUT);
+		GPIO_clr(GLN_GPIO_MMC_PWR_ON);
+
+	} else if ( ( 1 << vdd ) & p_d->ocr_mask ) {
+		printk(KERN_DEBUG "glencoe_mci_setpower: on\n");
+		pxa_gpio_mode(GLN_GPIO_MMC_PWR_ON | GPIO_OUT);
+		GPIO_set(GLN_GPIO_MMC_PWR_ON);
+	
+	} else 
+		printk(KERN_ERR "glencoe_mci_setpower: unable to set power\n");
+	
+}
+
+static void glencoe_mci_exit(struct device *dev, void *data)
+{ 
+	struct mmc_host *mmc = (struct mmc_host*)data;
+        unsigned long flags;
+
+        local_irq_save(flags); 
+	free_irq(GLENCOE_MMC_IRQ, (void *)mmc);
+	del_timer(&mmc_detect.detect_timer);
+        local_irq_restore(flags);
+}
+
+static struct pxamci_platform_data glencoe_mci_platform_data = {
+	.ocr_mask	= MMC_VDD_32_33|MMC_VDD_33_34,
+	.init 		= glencoe_mci_init,
+	.setpower 	= glencoe_mci_setpower,
+	.exit		= glencoe_mci_exit,
+};
+
+static void __init glencoe_init(void)
+{
+ 	/* system bus arbiter setting
+	 * - Core_Park
+	 * - LCD_wt:DMA_wt:CORE_Wt = 2:3:4
+	 */
+	ARB_CNTRL = ARB_CORE_PARK | 0x234;
+
+	GLN_SW_GREEN_LED_ON;
+
+#ifdef CONFIG_FB_PXA_LCD_VGA
+		set_pxa_fb_info(&toshiba_ltm04c380k);
+#elif	CONFIG_FB_PXA_LCD_QVGA
+		set_pxa_fb_info(&toshiba_ltm035a776c);
+#endif
+
+	pxa_set_mci_info(&glencoe_mci_platform_data);
+
+	// audio init
+	pxa_gpio_mode(GLN_GPIO_nAUDIO_PWR_DWN | GPIO_OUT);
+	GPIO_set(GLN_GPIO_nAUDIO_PWR_DWN);	// power up audio/ts codec
+	platform_device_register(&gln_audio_device);
+}
+
+static void __init glencoe_map_io(void)
+{
+	pxa_map_io();
+}
+
+MACHINE_START(GLENCOE, "Intel Beyond 3G Glencoe Platform")
+	MAINTAINER("Intel")
+	BOOT_MEM(0xa0000000, 0x40000000, io_p2v(0x40000000))
+	BOOT_PARAMS(0xa0000100)
+	MAPIO(glencoe_map_io)
+	INITIRQ(glencoe_init_irq)
+	INITTIME(pxa_init_time)
+	INIT_MACHINE(glencoe_init)
+MACHINE_END
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/ipmc.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/ipmc.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/ipmc.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/ipmc.c	2005-02-26 17:28:56.000000000 -0500
@@ -467,7 +467,7 @@
 		printk( KERN_INFO "Could not register device ipmc, res = %d.\n ",rc );
 		return -EBUSY;
 	}
-	printk( KERN_INFO "Register device ipmc successgul.\n " );
+	printk( KERN_INFO "Register device ipmc successful.\n " );
 	return 0;
 }
 
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/Kconfig linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/Kconfig
--- linux-2.6.9-intc1/arch/arm/mach-pxa/Kconfig	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/Kconfig	2005-04-25 15:54:29.000000000 -0400
@@ -13,7 +13,12 @@
 	bool "Intel HCDDBBVA0 Development Platform"
 	select PXA27x
 	select IWMMXT
-
+	
+config MACH_GLENCOE
+	bool "Intel B3G Glencoe Platform"
+	select PXA27x
+	select IWMMXT
+        
 config ARCH_PXA_IDP
 	bool "Accelent Xscale IDP"
 	select PXA25x
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/leds.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/leds.c	2004-10-18 17:55:29.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds.c	2005-02-22 19:15:36.000000000 -0500
@@ -22,6 +22,8 @@
 		leds_event = lubbock_leds_event;
 	if (machine_is_mainstone())
 		leds_event = mainstone_leds_event;
+	if (machine_is_glencoe())
+		leds_event = glencoe_leds_event;
 	if (machine_is_pxa_idp())
 		leds_event = idp_leds_event;
 
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/leds-glencoe.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds-glencoe.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/leds-glencoe.c	1969-12-31 19:00:00.000000000 -0500
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds-glencoe.c	2005-05-01 00:16:31.000000000 -0400
@@ -0,0 +1,140 @@
+/*
+ * linux/arch/arm/mach-pxa/leds-glencoe.c
+ *
+ * Modified from linux/arch/arm/mach-pxa/leds-lubbock.c
+ *   by Matthias Ihmig <m.ihmig@mytum.de>
+ * Copyright (C) 2000 John Dorsey <john+@cs.cmu.edu>
+ *
+ * Copyright (c) 2001 Jeff Sutherland <jeffs@accelent.com>
+ *
+ * Original (leds-footbridge.c) by Russell King
+ *
+ * See leds.h for bit definitions.  The first version defines D28 on the
+ * Lubbock dev board as the heartbeat, and D27 as the Sys_busy led.
+ * There's plenty more if you're interested in adding them :)
+ */
+
+
+#include <linux/config.h>
+#include <linux/init.h>
+
+#include <asm/hardware.h>
+#include <asm/leds.h>
+#include <asm/system.h>
+#include <asm/arch/pxa-regs.h>
+
+#include "leds.h"
+#include <asm/arch/glencoe.h>
+
+#define LED_STATE_ENABLED	1
+#define LED_STATE_CLAIMED	2
+
+#define HEARTBEAT_LED        1
+#define SYS_BUSY_LED         2
+
+static unsigned int led_state;
+static unsigned int hw_led_state;
+
+void glencoe_leds_event(led_event_t evt)
+{
+	unsigned long flags;
+
+	local_irq_save(flags);
+
+	switch (evt) {
+	case led_start:
+		hw_led_state = HEARTBEAT_LED | SYS_BUSY_LED;
+		led_state = LED_STATE_ENABLED;
+		break;
+
+	case led_stop:
+		led_state &= ~LED_STATE_ENABLED;
+		break;
+
+	case led_claim:
+		led_state |= LED_STATE_CLAIMED;
+		hw_led_state = HEARTBEAT_LED | SYS_BUSY_LED;
+		break;
+
+	case led_release:
+		led_state &= ~LED_STATE_CLAIMED;
+		hw_led_state = HEARTBEAT_LED | SYS_BUSY_LED;
+		break;
+
+#ifdef CONFIG_LEDS_TIMER
+	case led_timer:
+		if (!(led_state & LED_STATE_CLAIMED))
+			hw_led_state ^= HEARTBEAT_LED;
+		break;
+#endif
+
+#ifdef CONFIG_LEDS_CPU
+	case led_idle_start:
+		if (!(led_state & LED_STATE_CLAIMED))
+			hw_led_state |= SYS_BUSY_LED;
+		break;
+
+	case led_idle_end:
+		if (!(led_state & LED_STATE_CLAIMED))
+			hw_led_state &= ~SYS_BUSY_LED;
+		break;
+#endif
+
+	case led_halted:
+		break;
+
+	case led_green_on:
+		if (led_state & LED_STATE_CLAIMED)
+			hw_led_state &= ~HEARTBEAT_LED;
+		break;
+
+	case led_green_off:
+		if (led_state & LED_STATE_CLAIMED)
+			hw_led_state |= HEARTBEAT_LED;
+		break;
+
+	case led_amber_on:
+		break;
+
+	case led_amber_off:
+		break;
+
+	case led_red_on:
+		if (led_state & LED_STATE_CLAIMED)
+			hw_led_state &= ~SYS_BUSY_LED;
+		break;
+
+	case led_red_off:
+		if (led_state & LED_STATE_CLAIMED)
+			hw_led_state |= SYS_BUSY_LED;
+		break;
+
+	default:
+		break;
+	}
+
+	if  (led_state & LED_STATE_ENABLED)
+	{
+		switch (hw_led_state) {
+		case 0: // all on
+			HEARTBEAT_LED_ON;
+			SYS_BUSY_LED_ON;
+			break;
+		case 1: // turn off heartbeat, status on:
+			HEARTBEAT_LED_OFF;
+			SYS_BUSY_LED_ON;
+			break;
+		case 2: // status off, heartbeat on:
+			HEARTBEAT_LED_ON;
+			SYS_BUSY_LED_OFF;
+			break;
+		case 3: // turn them both off...
+			HEARTBEAT_LED_OFF;
+			SYS_BUSY_LED_OFF;
+			break;
+		default:
+			break;
+		}
+	}
+	local_irq_restore(flags);
+}
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/leds.h linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds.h
--- linux-2.6.9-intc1/arch/arm/mach-pxa/leds.h	2004-10-18 17:55:36.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/leds.h	2005-02-22 20:34:45.000000000 -0500
@@ -10,3 +10,4 @@
 extern void idp_leds_event(led_event_t evt);
 extern void lubbock_leds_event(led_event_t evt);
 extern void mainstone_leds_event(led_event_t evt);
+extern void glencoe_leds_event(led_event_t evt);
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/Makefile linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/Makefile
--- linux-2.6.9-intc1/arch/arm/mach-pxa/Makefile	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/Makefile	2005-05-01 14:54:02.000000000 -0400
@@ -10,12 +10,14 @@
 # Specific board support
 obj-$(CONFIG_ARCH_LUBBOCK) += lubbock.o
 obj-$(CONFIG_MACH_MAINSTONE) += mainstone.o
+obj-$(CONFIG_MACH_GLENCOE) += glencoe.o
 obj-$(CONFIG_ARCH_PXA_IDP) += idp.o
 
 # Support for blinky lights
 led-y := leds.o
 led-$(CONFIG_ARCH_LUBBOCK) += leds-lubbock.o
 led-$(CONFIG_MACH_MAINSTONE) += leds-mainstone.o
+led-$(CONFIG_MACH_GLENCOE) += leds-glencoe.o
 led-$(CONFIG_ARCH_PXA_IDP) += leds-idp.o
 
 obj-$(CONFIG_LEDS) += $(led-y)
diff -Nur linux-2.6.9-intc1/arch/arm/mach-pxa/pm.c linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/pm.c
--- linux-2.6.9-intc1/arch/arm/mach-pxa/pm.c	2005-05-02 15:16:11.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mach-pxa/pm.c	2005-04-21 20:40:13.000000000 -0400
@@ -21,12 +21,15 @@
 #include <linux/suspend.h>
 #include <linux/errno.h>
 #include <linux/time.h>
+#include <linux/delay.h>
 
 #include <asm/hardware.h>
 #include <asm/memory.h>
 #include <asm/system.h>
 #include <asm/arch/pxa-regs.h>
-#include <asm/arch/mainstone.h>
+#ifdef CONFIG_MACH_MAINSTONE
+	#include <asm/arch/mainstone.h>
+#endif
 #include <asm/mach/time.h>
 
 #include "cpu-freq-voltage-pxa27x.h"
@@ -38,6 +41,7 @@
 extern struct subsystem power_subsys;
 
 extern int pxa27x_set_voltage(unsigned int, unsigned int, unsigned int);
+extern unsigned int pxa27x_get_voltage(void);
 extern void pxa27x_cpufreq_restore(void);
 
 extern void pxa_cpu_suspend(void);
diff -Nur linux-2.6.9-intc1/arch/arm/mm/consistent.c linux-2.6.9-intc1-mih1/arch/arm/mm/consistent.c
--- linux-2.6.9-intc1/arch/arm/mm/consistent.c	2004-10-18 17:54:55.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/mm/consistent.c	2005-03-24 15:52:16.000000000 -0500
@@ -1,7 +1,7 @@
 /*
  *  linux/arch/arm/mm/consistent.c
  *
- *  Copyright (C) 2000-2002 Russell King
+ *  Copyright (C) 2000-2004 Russell King
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
@@ -30,7 +30,7 @@
  * This is the page table (2MB) covering uncached, DMA consistent allocations
  */
 static pte_t *consistent_pte;
-static spinlock_t consistent_lock = SPIN_LOCK_UNLOCKED;
+static DEFINE_SPINLOCK(consistent_lock);
 
 /*
  * VM region handling support.
@@ -65,6 +65,7 @@
 	struct list_head	vm_list;
 	unsigned long		vm_start;
 	unsigned long		vm_end;
+	struct page		*vm_pages;
 };
 
 static struct vm_region consistent_head = {
@@ -206,6 +207,8 @@
 		pte_t *pte = consistent_pte + CONSISTENT_OFFSET(c->vm_start);
 		struct page *end = page + (1 << order);
 
+		c->vm_pages = page;
+
 		/*
 		 * Set the "dma handle"
 		 */
@@ -215,6 +218,9 @@
 			BUG_ON(!pte_none(*pte));
 
 			set_page_count(page, 1);
+			/*
+			 * x86 does not mark the pages reserved...
+			 */
 			SetPageReserved(page);
 			set_pte(pte, mk_pte(page, prot));
 			page++;
@@ -264,6 +270,53 @@
 }
 EXPORT_SYMBOL(dma_alloc_writecombine);
 
+static int dma_mmap(struct device *dev, struct vm_area_struct *vma,
+		    void *cpu_addr, dma_addr_t dma_addr, size_t size)
+{
+	unsigned long flags, user_size, kern_size;
+	struct vm_region *c;
+	int ret = -ENXIO;
+
+	user_size = (vma->vm_end - vma->vm_start) >> PAGE_SHIFT;
+
+	spin_lock_irqsave(&consistent_lock, flags);
+	c = vm_region_find(&consistent_head, (unsigned long)cpu_addr);
+	spin_unlock_irqrestore(&consistent_lock, flags);
+
+	if (c) {
+		unsigned long off = vma->vm_pgoff;
+
+		kern_size = (c->vm_end - c->vm_start) >> PAGE_SHIFT;
+
+		if (off < kern_size &&
+		    user_size <= (kern_size - off)) {
+			vma->vm_flags |= VM_RESERVED;
+			ret = remap_pfn_range(vma, vma->vm_start,
+					      page_to_pfn(c->vm_pages) + off,
+					      user_size << PAGE_SHIFT,
+					      vma->vm_page_prot);
+		}
+	}
+
+	return ret;
+}
+
+int dma_mmap_coherent(struct device *dev, struct vm_area_struct *vma,
+		      void *cpu_addr, dma_addr_t dma_addr, size_t size)
+{
+	vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
+	return dma_mmap(dev, vma, cpu_addr, dma_addr, size);
+}
+EXPORT_SYMBOL(dma_mmap_coherent);
+
+int dma_mmap_writecombine(struct device *dev, struct vm_area_struct *vma,
+			  void *cpu_addr, dma_addr_t dma_addr, size_t size)
+{
+	vma->vm_page_prot = pgprot_writecombine(vma->vm_page_prot);
+	return dma_mmap(dev, vma, cpu_addr, dma_addr, size);
+}
+EXPORT_SYMBOL(dma_mmap_writecombine);
+
 /*
  * free a page as defined by the above mapping.
  */
@@ -300,6 +353,10 @@
 
 			if (pfn_valid(pfn)) {
 				struct page *page = pfn_to_page(pfn);
+
+				/*
+				 * x86 does not mark the pages reserved...
+				 */
 				ClearPageReserved(page);
 
 				__free_page(page);
diff -Nur linux-2.6.9-intc1/arch/arm/tools/mach-types linux-2.6.9-intc1-mih1/arch/arm/tools/mach-types
--- linux-2.6.9-intc1/arch/arm/tools/mach-types	2004-10-18 17:54:08.000000000 -0400
+++ linux-2.6.9-intc1-mih1/arch/arm/tools/mach-types	2005-02-22 19:25:52.000000000 -0500
@@ -615,3 +615,4 @@
 tomtomgo		MACH_TOMTOMGO		TOMTOMGO		605
 versatile_ab		MACH_VERSATILE_AB	VERSATILE_AB		606
 edb9307			MACH_EDB9307		EDB9307			607
+glencoe			MACH_GLENCOE		GLENCOE			4061
